#include "stdafx.h"
#include "MyBar.h"

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyBar::CMyBar(HWND hParentWnd)
{
   m_hParentWnd   = hParentWnd;
   m_hBar         = NULL;
   m_nHeight      = 0;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyBar::~CMyBar()
{
   if (m_hBar != NULL) {
		DestroyWindow(m_hBar);
		m_hBar = NULL;
	}
	m_hParentWnd   = NULL;
	m_nHeight      = 0;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyBar::CreateBar(HWND hParentWnd)
{
	RECT rtBar;
	// Test rodicovskeho okna
	if (m_hParentWnd == NULL) m_hParentWnd = hParentWnd;
	if (m_hParentWnd == NULL) return(FALSE);
	// Inicializace CommonControls a zavolani virtualni fce na vytvoreni ...bary
	InitCommonControls();
	if (m_hBar != NULL) {
		DestroyWindow(m_hBar);
		m_hBar		= NULL;
		m_nHeight	= 0;
	}
   if (!BarCreate()) return(FALSE);
   // Pokud se ...bara nevytvorila, vrat FALSE
   if (m_hBar == NULL) return(FALSE);
   // Jinak spocti jeji velikost a vrat TRUE
   GetWindowRect(m_hBar, &rtBar);
   m_nHeight = rtBar.bottom - rtBar.top;

   return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyBar::ChangeViewStatus()
{
	// Vstupni test
	if (m_hBar == NULL) return(FALSE);
	// Je-li velikost > 0 neboli je ...bara zobrazena
	if (m_nHeight > 0) {
		// Pokus se skryt ...baru a nastav velikost na 0
		ShowWindow(m_hBar, SW_HIDE);
		m_nHeight = 0;
	}
	else {
		RECT rtBar;
		// Jinak zobraz ...baru a spocti velikost
		ShowWindow(m_hBar, SW_SHOW);
		GetWindowRect(m_hBar, &rtBar);
		m_nHeight = rtBar.bottom - rtBar.top;
	}
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyBar::Destroy()
{
	if (m_hBar == NULL) return(FALSE);

	if (!::DestroyWindow(m_hBar)) return(FALSE);

	m_hBar = NULL;

	return(TRUE);
}
