#ifndef MyBarH
#define MyBarH

#include <windows.h>
#include <commctrl.h>   // musi predchazet #include <windows.h>
#include "MyObject.h"

/** Tda CMyBar je abstraktn tda jako zakladn Toolbaru a Statusbaru
   Obsahuje ve co maj spolen.*/
class __declspec(dllexport) CMyBar : public CMyObject {
// Konstruktory a destruktor
public:
   /** Konstruktor (HWND)
      @param hParentWnd ... handle rodiovskho okna */
   CMyBar(HWND hParentWnd = NULL);
   /** Destruktor */
   virtual ~CMyBar();

protected:

private:


// Funkce a metody
public:
   /** Vytvoeni ...bary.<BR>
      Obsahuje pouze testy, samotn vytvoen okna je penechno na virtualn
      fci BarCreate(), kterou MUS zddn classa pekrt.<BR>
      Vrt FALSE pokud nen nastaveno rodiovskho okno nebo se nepodarilo ...baru
      vytvoit, pi spchu vrt TRUE.<BR>
      @param hParentWnd ... handle rodiovskho okna, mus bt nastaven pokud nebyl
         nastaven v konstruktoru */
   BOOL                 CreateBar(HWND hParentWnd = NULL);
   /** Vrt aktuln vku ...bary, pokud nen ...bara vytvorena nebo
      je skryta, vrt 0*/
   inline int           GetBarHeight() {
      return(m_nHeight);
   };
   /** Vrt handle ...bary nebo NULL */
   inline HWND          GetHandle() {
      return(m_hBar);
   };
   /** Zmna viditelnosti ...bary.
      Zmn viditelnost ...bary, pokud se j nepodailo zmnit vrt FALSE, jinak
      (pi spchu) vrt TRUE */
   virtual BOOL			ChangeViewStatus();
   /** Vrt TRUE pokud je ...bara zobrazena, jinak FALSE */
   inline BOOL          IsShowed() {
      return(m_nHeight > 0);
   };
   /** Virtualn fce na zmnu velikosti okna, kter MUS bt volna po zmn velikosti
      rodiovskho okna (po zddn nutno implementovat)*/
	virtual int          Resize() = 0;
	/***/
	BOOL						Destroy();

protected:

private:
   /** Virtuln fce na samotn vytvoen ...bary (po zddn nutno implementovat)*/
   virtual BOOL         BarCreate() = 0;




// Atributy a datove cleny
public:

protected:
   /** Handle rodiovskho okna */
   HWND                 m_hParentWnd;
   /** Handle ...bary */
   HWND                 m_hBar;
   /** Aktualn vka ...bary, pokud nen ...bara zobrazena je vka == 0*/
   UINT                 m_nHeight;

private:

};



#endif
