#ifndef MySplitterWindowH
#define MySplitterWindowH

#include <windows.h>
#include "MyWindow.h"


#define MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT			0x01
#define MY_SPLITTER_WINDOW_SPLIT_TYPE_BOTTOM_RIGHT		0x02
#define MY_SPLITTER_WINDOW_SPLIT_TYPE_PERCENTAGE		0x04
#define MY_SPLITTER_WINDOW_SPLIT_TYPE_SHOW_HEADER		0x80


/** Tda CMySplitterWindow je zkladn tdou pro rozdlovnky (horizontln
	a vertikln). Obsahuje spolen a obecn kd. */
class __declspec(dllexport) CMySplitterWindow : public CMyWindow {
//Konstruktory a destruktor
public:
	/** Destruktor*/
	virtual ~CMySplitterWindow();

protected:
	/** Implicitn konstruktor - ureno pouze pro ddn */
	CMySplitterWindow(LPCWSTR pwzClassName, UINT nCursorID);

private:



//Funkce a metody
public:
	/***/
	virtual BOOL						CreateMyEx(LPCWSTR pwzTitle, DWORD dwStyle, DWORD dwStyleEx, CMyWindow* pParentWindow, UINT nMenu = 0,
													UINT nBigIcon = 0, UINT nSmallIcon = 0, RECT* pPosition = NULL);
	/** Pozice splitteru.<BR>
		Vrac aktuln pozici splitteru nebo -1 pokud nen vytvoen.*/
	int                           GetSplitterPos();
	/** Nastaven pozice splitteru.<BR>
		Nastav aktuln pozici splitteru.*/
	void									SetSplitterPos(UINT nSplitterPos);
	/** Velikost levho pohledu.<BR>
		Vypln do zadan promnn obdlnk levho (hornho) pohledu.<BR>
		@param pRect ... pointer na promnnou typu RECT, do kter (pokud nen NULL) se
			vypln velikost levho (hornho) pohledu */
	virtual BOOL						GetLeftRect(RECT* pRect);
	/** Velikost pravho pohledu.<BR>
		Vypln do zadan promnn obdlnk pravho (dolnho) pohledu.<BR>
		@param pRect ... pointer na promnnou typu RECT, do kter (pokud nen NULL) se
			vypln velikost pravho (dolnho) pohledu */
	virtual BOOL						GetRightRect(RECT* pRect);
	/** Nastaven pohled.<BR>
		Nastav lev a prav pohled, kter jeji funkce na zmnu velikosti budou volny.<BR>
		@param m_pLeftView ...
		@param m_pRightView ... */
	void                          SetView(CMyWindow* pLeftView, CMyWindow* pRightView);
	/** Zmna velikosti okna */
	virtual BOOL						Resize(RECT* pClientRect = NULL);	
	/** Vrac typ rozdlovnku */
	BYTE									GetSplitType();
	/** Nastaven typu rozdlovnku */
	void									SetSplitType(BYTE nSplitType);	


protected:	
	/***/
	virtual BOOL						OnCommand(WPARAM wParam, LPARAM lParam);
	/** Vymazn pozad okna.<BR>
		Reakce na zprvu WM_ERASEBKGND, vymazn pozad okna.<BR>
		@param hDC ... handle DC okna, kam se m kreslit */
	virtual BOOL						OnEraseBkgnd(HDC hDC);
	/***/
	virtual BOOL						OnLButtonDown(DWORD dwKeyIndicator, int nPositionX, int nPositionY);
	/***/
	virtual BOOL						OnLButtonUp(DWORD dwKeyIndicator, int nPositionX, int nPositionY);
	
private:
	/** Zmna velikosti okna */
	virtual void						ResizeView(int nPosition, BOOL bEndDrag);
	/** Zmna velikosti podoken */
	virtual void						ResizeChildView();	



//Atributy a datove cleny
public:

protected:

private:
	/** Soiasn pozice rozdlovnku */
	int									m_nCurrentPosition;
	/** Reln pozice rodlovnku */
	int									m_nRealPosition;
	/** Uloen pozice rozdlovnku */
	int									m_nSavedPosition;
	/** Posledn pozice rozdlovnku */
	int									m_nLastPosition;
	/** Lev nebo horn okno */
	CMyWindow*							m_pLeftView;
	/** Prav nebo spodn okno */
	CMyWindow*							m_pRightView;	
	/** Flag pro oznaen stavu, kdy mnme velikost okna */
	BOOL									m_bSize;
	/** Typ rozdlovnku */
	BYTE									m_nSplitType;	

friend class CMyVerticalSplitter;
friend class CMyHorizontalSplitter;

};

#endif


//Vygenerovno prostrednictvm ClassGen 1.10.001
