#include "stdafx.h"
#include "MyTreeView.h"


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyTreeView::CMyTreeView() : CMyWindow(WC_TREEVIEW)
{
	INITCOMMONCONTROLSEX	sInitCommonControl;

	sInitCommonControl.dwSize	= sizeof(INITCOMMONCONTROLSEX);
	sInitCommonControl.dwICC	= ICC_TREEVIEW_CLASSES;

	InitCommonControlsEx(&sInitCommonControl);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyTreeView::~CMyTreeView()
{
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HIMAGELIST CMyTreeView::CreateDragImage(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_CreateDragImage(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::DeleteAllItems()
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_DeleteAllItems(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::DeleteItem(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	return(TreeView_DeleteItem(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HWND CMyTreeView::EditLabel(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_EditLabel(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::EndEditLabelNow(BOOL bCancel)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_EndEditLabelNow(m_hWnd, bCancel));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::EnsureVisible(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	return(TreeView_EnsureVisible(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::Expand(HTREEITEM hItem, UINT nFlag)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	return(TreeView_Expand(m_hWnd, hItem, nFlag));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::GetBkColor()
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_GetBkColor(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetCheckState(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(0);
	if (hItem == NULL) return(0);

	return(TreeView_GetCheckState(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetChild(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetChild(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetCount()
{
	if (m_hWnd == NULL) return(0);

	return(TreeView_GetCount(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetDropHilight()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetDropHilight(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HWND CMyTreeView::GetEditControl()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetEditControl(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetFirstVisible()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetFirstVisible(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HIMAGELIST CMyTreeView::GetImageList(INT nImage)
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetImageList(m_hWnd, nImage));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetIndent()
{
	if (m_hWnd == NULL) return(0);

	return(TreeView_GetIndent(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::GetInsertMarkColor()
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_GetInsertMarkColor(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::GetISearchString(LPCWSTR pwzString)
{
	if (m_hWnd == NULL) return(FALSE);
	if (pwzString == NULL) return(FALSE);

	return(TreeView_GetISearchString(m_hWnd, pwzString));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::GetItem(LPTVITEM psItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (psItem == NULL) return(NULL);

	return(TreeView_GetItem(m_hWnd, psItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::GetItemEx(LPTVITEMEX psItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (psItem == NULL) return(NULL);

	return(TreeView_GetItem(m_hWnd, psItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
int CMyTreeView::GetItemHeight()
{
	if (m_hWnd == NULL) return(-1);

	return(TreeView_GetItemHeight(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::GetItemRect(HTREEITEM hItem, RECT* pRect, BOOL bItemRect)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);
	if (pRect == NULL) return(FALSE);

	return(TreeView_GetItemRect(m_hWnd, hItem, pRect, bItemRect));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetItemState(HTREEITEM hItem, UINT nStateMask)
{
	if (m_hWnd == NULL) return(0);
	if (hItem == NULL) return(0);

	return(TreeView_GetItemState(m_hWnd, hItem, nStateMask));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetLastVisible()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetLastVisible(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::GetLineColor()
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_GetLineColor(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetNextItem(HTREEITEM hItem, UINT nFlag)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetNextItem(m_hWnd, hItem, nFlag));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetNextSibling(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetNextSibling(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetNextVisible(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetNextVisible(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetParent(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetParent(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetPrevSibling(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetPrevSibling(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetPrevVisible(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(NULL);
	if (hItem == NULL) return(NULL);

	return(TreeView_GetPrevVisible(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetRoot()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetRoot(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetScrollTime()
{
	if (m_hWnd == NULL) return(0);

	return(TreeView_GetScrollTime(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::GetSelection()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetSelection(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::GetTextColor()
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_GetTextColor(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HWND CMyTreeView::GetToolTips()
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_GetToolTips(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::GetUnicodeFormat()
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_GetUnicodeFormat(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::GetVisibleCount()
{
	if (m_hWnd == NULL) return(0);

	return(TreeView_GetVisibleCount(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::HitTest(LPTVHITTESTINFO psHitTestInfo)
{
	if (m_hWnd == NULL) return(NULL);
	if (psHitTestInfo == NULL) return(NULL);

	return(TreeView_HitTest(m_hWnd, psHitTestInfo));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTREEITEM CMyTreeView::InsertItem(LPTVINSERTSTRUCT psInsert)
{
	HTREEITEM	hItem;

	if (m_hWnd == NULL) return(NULL);
	if (psInsert == NULL) return(NULL);

	hItem = TreeView_InsertItem(m_hWnd, psInsert);

	#ifdef _DEBUG
		if (hItem == NULL) {
			DWORD	dwError = GetLastError();
			assert(0);
			dwError = dwError;
		}
	#endif

	return(hItem);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::Select(HTREEITEM hItem, UINT nFlag)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_Select(m_hWnd, hItem, nFlag));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SelectDropTarget(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SelectDropTarget(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SelectItem(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SelectItem(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SelectSetFirstVisible(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SelectSetFirstVisible(m_hWnd, hItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::SetBkColor(COLORREF clColor)
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_SetBkColor(m_hWnd, clColor));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetCheckState(HTREEITEM hItem, BOOL bCheck)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	TreeView_SetCheckState(m_hWnd, hItem, bCheck);

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HIMAGELIST CMyTreeView::SetImageList(HIMAGELIST hImageList, INT nImage)
{
	if (m_hWnd == NULL) return(NULL);

	return(TreeView_SetImageList(m_hWnd, hImageList, nImage));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetIndent(INT nIndent)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SetIndent(m_hWnd, nIndent));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetInsertMark(HTREEITEM hItem, BOOL bAfter)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SetInsertMark(m_hWnd, hItem, bAfter));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::SetInsertMarkColor(COLORREF clColor)
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_SetInsertMarkColor(m_hWnd, clColor));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetItem(LPTVITEM psItem)
{
	if (m_hWnd == NULL) return(FALSE);
	if (psItem == NULL) return(FALSE);

	return(TreeView_SetItem(m_hWnd, psItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetItemEx(LPTVITEMEX psItem)
{
	if (m_hWnd == NULL) return(FALSE);
	if (psItem == NULL) return(FALSE);

	return(TreeView_SetItem(m_hWnd, psItem));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
int CMyTreeView::SetItemHeight(SHORT nHeight)
{
	if (m_hWnd == NULL) return(-1);

	return(TreeView_SetItemHeight(m_hWnd, nHeight));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetItemState(HTREEITEM hItem, UINT nState, UINT nStateMask)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	TreeView_SetItemState(m_hWnd, hItem, nState, nStateMask);

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::SetLineColor(COLORREF clColor)
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_SetLineColor(m_hWnd, clColor));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UINT CMyTreeView::SetScrollTime(UINT nMaxScrollTime)
{
	if (m_hWnd == NULL) return(0);

	return(TreeView_SetScrollTime(m_hWnd, nMaxScrollTime));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COLORREF CMyTreeView::SetTextColor(COLORREF clColor)
{
	if (m_hWnd == NULL) return(CLR_DEFAULT);

	return(TreeView_SetTextColor(m_hWnd, clColor));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HWND CMyTreeView::SetToolTips(HWND hTooltip)
{
	if (m_hWnd == NULL) return(NULL);
	if (hTooltip == NULL) return(NULL);

	return(TreeView_SetToolTips(m_hWnd, hTooltip));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SetUnicodeFormat(BOOL bUnicode)
{
	if (m_hWnd == NULL) return(FALSE);

	return(TreeView_SetUnicodeFormat(m_hWnd, bUnicode));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SortChildren(HTREEITEM hItem)
{
	if (m_hWnd == NULL) return(FALSE);
	if (hItem == NULL) return(FALSE);

	return(TreeView_SortChildren(m_hWnd, hItem, FALSE));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyTreeView::SortChildrenCB(LPTVSORTCB psSort)
{
	if (m_hWnd == NULL) return(FALSE);
	if (psSort == NULL) return(FALSE);

	return(TreeView_SortChildrenCB(m_hWnd, psSort, FALSE));
}

