#ifndef ListViewPanelH
#define ListViewPanelH

#include <windows.h>
#include "..\\MyDLL\\MyPanel.h"
#include "..\\MyDLL\\MyListView.h"

typedef struct _LIST_VIEW_STRUCT {

	wchar_t					wzName[MAX_PATH];

	BYTE						nType;

	_LIST_VIEW_STRUCT*	pNext;

} LIST_VIEW_STRUCT;


/** Tda CListViewPanel */
class CListViewPanel : public CMyPanel {
//Konstruktory a destruktor
public:
	/** Implicitn konstruktor*/
	CListViewPanel();
	/** Destruktor*/
	virtual ~CListViewPanel();

protected:

private:


//Funkce a metody
public:

	virtual BOOL						Resize(RECT* pClientRect = NULL);

	void									ChangeFolder(LPCWSTR pwzFolder);

protected:
	/***/
	virtual BOOL						OnCreate(LPCREATESTRUCT psCreateStruct);
	
	virtual BOOL						OnEraseBkgnd(HDC hDC);

	virtual BOOL						OnNotify(WPARAM wParam, LPARAM lParam);	

private:

	void									InitImageList();

	void									InitListView();

	void									InsertBitmap(UINT nID);

	void									FreeList();

	LIST_VIEW_STRUCT*					InsertListItem(LPCWSTR pwzName, BYTE nType);

	void									ClearList();

	void									OnItemActivate(int nItemIndex);

	static int CALLBACK				CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);



//Atributy a datove cleny
public:

protected:

private:

	HIMAGELIST							m_hImageList;

	CMyListView							m_hListView;	

	LIST_VIEW_STRUCT					m_sItemList;	

};

#endif
