#include "stdafx.h"
#include "MainView.h"
#include "resource.h"


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMainView::CMainView() : CMyWindow(L"_Test_Main_View_")
{		
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMainView::~CMainView()
{			
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMainView::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(LOWORD(wParam)) {
		case(ID_TREE_VIEW):
			if (HIWORD(wParam) == 1) {
				m_hStatusbar.SetBarText((LPCWSTR)lParam);
				m_hListViewPanel.ChangeFolder((LPCWSTR)lParam);
			}
			break;
		case(IDM_MENU_COMMAND_UP):
			m_hTreeViewPanel.ChangeItem(L"..");
			break;
		case(ID_LIST_VIEW):
			if (HIWORD(wParam) == 1) m_hTreeViewPanel.ChangeItem((LPCWSTR)lParam);
			break;
		case(IDM_MENU_FILE_EXIT):			
			OnClose();
			break;
		case(IDM_MENU_SHOW_TOOLBAR):
			OnShowBar(&m_hToolbar, LOWORD(wParam));
			break;
		case(IDM_MENU_SHOW_STATUSBAR):
			OnShowBar(&m_hStatusbar, LOWORD(wParam));
			break;			
	};

	return(FALSE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMainView::OnCreate(LPCREATESTRUCT psCreateStruct)
{
	RECT	rtRect;	

	GetClientRect(&rtRect);

	m_hStatusbar.CreateBar(m_hWnd);
	m_hToolbar.CreateBar(m_hWnd);

	rtRect.top += m_hToolbar.GetBarHeight();
	rtRect.bottom -= m_hStatusbar.GetBarHeight();

	m_hVertical.CreateMy(L"", WS_CHILD | WS_VISIBLE, this, 0, 0, 0, &rtRect);

	m_hVertical.GetLeftRect(&rtRect);
	m_hTreeViewPanel.CreateMyEx(L"", WS_CHILD | WS_VISIBLE, 0, &m_hVertical, 0, 0, 0, &rtRect);

	m_hVertical.GetRightRect(&rtRect);
	m_hListViewPanel.CreateMyEx(L"", WS_CHILD | WS_VISIBLE, 0, &m_hVertical, 0, 0, 0, &rtRect);

	m_hVertical.SetView(&m_hTreeViewPanel, &m_hListViewPanel);		

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMainView::OnDestroy()
{
	PostQuitMessage(0);

	return(CMyWindow::OnDestroy());
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMainView::OnEraseBkgnd(HDC hDC)
{
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMainView::OnSize(DWORD dwResizingFlag, WORD wNewWidth, WORD wNewHeight)
{
	BOOL	bRet = CMyWindow::OnSize(dwResizingFlag, wNewWidth, wNewHeight);
	RECT	rtRect;

	GetClientRect(&rtRect);

	m_hToolbar.Resize();
	m_hStatusbar.Resize();

	rtRect.top += m_hToolbar.GetBarHeight();
	rtRect.bottom -= m_hStatusbar.GetBarHeight();

	m_hVertical.Resize(&rtRect);

	return(bRet);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMainView::OnShowBar(CMyBar* pBar, UINT nMenuID)
{	
	HMENU	hMenu	= GetMenu(m_hWnd);

	assert(pBar != NULL);

	pBar->ChangeViewStatus();
			
	CheckMenuItem(hMenu, nMenuID, pBar->IsShowed());

	OnSize(0, 0, 0);
}
/*
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMainView::OnShowToolbar()
{
	HMENU	hMenu	= GetMenu(m_hWnd);

	m_hToolbar.ChangeViewStatus();

	CheckMenuItem(hMenu, IDM_MENU_SHOW_TOOLBAR, m_hToolbar.IsShowed());
			
	OnSize(0, 0, 0);	
}
*/