#include "stdafx.h"
#include "Toolbar.h"
#include "resource.h"

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CToolbar::CToolbar()
{	
	m_hImageList	= NULL;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CToolbar::~CToolbar()
{
	if (m_hImageList != NULL) {
		ImageList_Destroy(m_hImageList);
		m_hImageList = NULL;
	}
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CToolbar::BarCreate()
{
	INITCOMMONCONTROLSEX sInitEx;
	BOOL						bRet;
	HINSTANCE				hInst = (HINSTANCE)GetWindowLong(m_hParentWnd, GWL_HINSTANCE);

	if (hInst == NULL) return(FALSE);

	sInitEx.dwSize	= sizeof(INITCOMMONCONTROLSEX);
	sInitEx.dwICC	= ICC_BAR_CLASSES;
	InitCommonControlsEx(&sInitEx);
  		
	InitButton();

	m_hBar = CreateToolbarEx(m_hParentWnd, WS_VISIBLE | WS_CHILD/* | WS_BORDER*/,
		IDC_TB_TOOLBAR, TOOLBAR_BUTTON_COUNT, hInst, IDB_TOOLBAR, (LPTBBUTTON)&m_tbButton, TOOLBAR_BUTTON_COUNT,
		16, 16, 16, 16, sizeof(TBBUTTON));

	m_hImageList = ImageList_Create(16, 16, ILC_COLOR24 | ILC_MASK, TOOLBAR_BUTTON_COUNT, 0);

	HBITMAP hBitmap;
	// 0
	hBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_TOOLBAR_EXIT));
	ImageList_AddMasked(m_hImageList, hBitmap, RGB(0, 0, 0));
	if (!DeleteObject(hBitmap)) {
		assert(0);
	}	
	// 1
	hBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_TOOLBAR_UP));
	ImageList_AddMasked(m_hImageList, hBitmap, RGB(0, 0, 0));
	if (!DeleteObject(hBitmap)) {
		assert(0);
	}	

	bRet = SendMessage(m_hBar, TB_SETIMAGELIST, (WPARAM)0, (LPARAM)m_hImageList);	
	assert(bRet);

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CToolbar::InitButton()
{
	int nBitmap = 0;

	/* Zde pridat ID tlacitek a v MainView pridat do WindowProc reakci na WM_NOTIFY pro tooltipy */
	for (int i = 0;i < TOOLBAR_BUTTON_COUNT;i++) {
		m_tbButton[i].iBitmap   = nBitmap;
		m_tbButton[i].fsState   = TBSTATE_ENABLED;
		m_tbButton[i].fsStyle   = TBSTYLE_BUTTON;// | TBSTYLE_TOOLTIPS;
		m_tbButton[i].dwData    = 0;
		m_tbButton[i].iString   = 0;
		
		nBitmap++;
	}

	m_tbButton[0].idCommand 	= IDM_MENU_FILE_EXIT;	
	m_tbButton[1].idCommand 	= IDM_MENU_COMMAND_UP;
}